class GeomParticle extends Particle3D{
  FuzzColor fuzzColor;
  color c;
  Force f;
  float sizeA;
  GeomParticle(int lifetime, float x, float y, float z, float vx,float vy, float vz,FuzzColor fuzzColor,Force f) {
    super(lifetime, x, y, z, vx, vy, vz,f);
    this.fuzzColor = fuzzColor;
    c = color(random(fuzzColor.h-fuzzColor.fuzzH/2,fuzzColor.h+fuzzColor.fuzzH/2),random(fuzzColor.s-fuzzColor.fuzzS/2,fuzzColor.s+fuzzColor.fuzzS/2),random(fuzzColor.b-fuzzColor.fuzzB/2,fuzzColor.b+fuzzColor.fuzzB/2));
    sizeA = myFFT.averages[freqForSize] * 300;
  }
  void draw(){
    noStroke();

    pushMatrix();
    translate(position[0],position[1],position[2]);
    drawSprite();
    popMatrix();
  }

  void drawSolidDisc(){
    fill(c);
    beginShape(TRIANGLE_FAN);
    vertex(0,0,0);
    for(int i=0;i<circle1.getNumOfDivision();i++){
      vertex(circle1.getCosLUT(i)*sizeA,circle1.getSinLUT(i)*sizeA,0);
    }
    vertex(circle1.getCosLUT(0)*sizeA,circle1.getSinLUT(0)*sizeA,0);
    endShape(CLOSE);
  }

  void drawSprite(){
    textureMode(NORMALIZED);
    fill(c);
    beginShape();
    texture(tex);
    vertex(sizeA,sizeA,0,1,1);
    vertex(sizeA,-1*sizeA,0,1,0);
    vertex(-1*sizeA,-1*sizeA,0,0,0);
    vertex(-1*sizeA,sizeA,0,0,1);
    endShape(CLOSE);
  }
  void drawXSprite(){
    textureMode(NORMALIZED);
    fill(c);
    beginShape();
    texture(tex);
    vertex(sizeA,sizeA,0,1,1);
    vertex(sizeA,-1*sizeA,0,1,0);
    vertex(-1*sizeA,-1*sizeA,0,0,0);
    vertex(-1*sizeA,sizeA,0,0,1);
    endShape(CLOSE);
    pushMatrix();
    rotateX(PI/2);
    beginShape();
    texture(tex);
    vertex(sizeA,sizeA,0,1,1);
    vertex(sizeA,-1*sizeA,0,1,0);
    vertex(-1*sizeA,-1*sizeA,0,0,0);
    vertex(-1*sizeA,sizeA,0,0,1);
    endShape(CLOSE);
    popMatrix();
    rotateY(PI/2);
    beginShape();
    texture(tex);
    vertex(sizeA,sizeA,0,1,1);
    vertex(sizeA,-1*sizeA,0,1,0);
    vertex(-1*sizeA,-1*sizeA,0,0,0);
    vertex(-1*sizeA,sizeA,0,0,1);
    endShape(CLOSE);
  }
  void update(){
    super.update();
  }
}


